<?php
	include_once('SmartIRC/defines.php');
	require_once('SmartIRC/SmartIRC.php');
	require_once('config-irc.php');
	if (!$PluginConfig["irc"]["server"] || $PluginConfig["irc"]["channel"] == array("#bottestchannel_1","#bottestchannel_2"))
	{
		define('IRCDISABLED',TRUE);
		say("IRC :: is disabled. Edit config-irc.php.");
		sleep(10);
		return;
	}
	class RageIRC extends Net_SmartIRC
	{
		var $RageIRCPlugin;
	    function RageParse_Channel(&$irc, &$data)
	    {
			say('IRC['.$data->channel.'] '.$data->nick.' :: '.$data->message,1);
			include($this->RageIRCPlugin.'/channel.php');
	    }
		function RageParse_Query(&$irc, &$data)
		{
			say('IRC[:QUERY:] '.$data->nick.' :: '.$data->message,1);
			include($this->RageIRCPlugin.'/query.php');
		}
		function RageParse_Notice(&$irc, &$data)
		{
			say('IRC[:NOTICE:] '.$data->nick.' :: '.$data->message,1);
			include($this->RageIRCPlugin.'/notice.php');
		}
	    function RageParse_Kick(&$irc, &$data)
	    {
			say('IRC['.$data->channel.'] [KICKED] '.$data->nick,1);
			include($this->RageIRCPlugin.'/channel_kick.php');
	    }		
	    function RageParse_Join(&$irc, &$data)
	    {
			say('IRC['.$data->channel.'] [JOINED] '.$data->nick,1);
			include($this->RageIRCPlugin.'/channel_join.php');
	    }		
	    function RageParse_Part(&$irc, &$data)
	    {
			say('IRC['.$data->channel.'] [LEFT] '.$data->nick,1);
			include($this->RageIRCPlugin.'/channel_part.php');
	    }		
	    function RageTimer_Ping(&$irc)
	    {
    		if (time()-$irc->_lastrx > 120) {
                say('IRC[Timer] RECONNECT forced (link idle)',1);
    			$irc->reconnect();
    			$irc->_lastrx = time();
    		}
            $irc->_send('PING '.$irc->_address, SMARTIRC_CRITICAL);
			say('IRC[Timer] PING forced',1);
	    }
    }
	function IRCConnect($RageIRCPlugin) {
		global $PluginConfig;
		$IRC = &new RageIRC();
		$IRC->_maxtimer=50;
		$IRC->RageIRCPlugin=$RageIRCPlugin;
		$IRC->setUseSockets(true);
		$IRC->setChannelSyncing(true);
		$IRC->setAutoReconnect(true);
		if ($PluginConfig["irc"]["debug"]) $IRC->setDebug(SMARTIRC_DEBUG_ALL);
		$IRC->registerActionhandler(SMARTIRC_TYPE_NOTICE,  '.*', $IRC, 'RageParse_Notice');
		$IRC->registerActionhandler(SMARTIRC_TYPE_JOIN,    '.*', $IRC, 'RageParse_Join');
		$IRC->registerActionhandler(SMARTIRC_TYPE_PART,    '.*', $IRC, 'RageParse_Part');
		$IRC->registerActionhandler(SMARTIRC_TYPE_KICK,    '.*', $IRC, 'RageParse_Kick');
		$IRC->registerActionhandler(SMARTIRC_TYPE_QUERY,   '.*', $IRC, 'RageParse_Query');
		$IRC->registerActionhandler(SMARTIRC_TYPE_CHANNEL, '.*', $IRC, 'RageParse_Channel');
        $IRC->registerTimehandler(20000, $IRC,'RageTimer_Ping'); # 20 seconds

		$IRC->connect(
			$PluginConfig["irc"]["server"], 
			$PluginConfig["irc"]["port"]
			);
		$IRC->login(
			$PluginConfig["irc"]["nick"], 
			$PluginConfig["irc"]["realname"], 
			8, #usermode: 0=normal, 8=invisible
			$PluginConfig["irc"]["username"], 
			$PluginConfig["irc"]["password"]
			);
		$IRC->join(	$PluginConfig["irc"]["channel"] );
		return $IRC;
	}
	
?>